------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Abstract_Item_Models;
limited with Qt4.Abstract_Item_Views;
with Qt4.Model_Indices;
with Qt4.Objects;
with Qt4.Rects;
with Qt4.Strings;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Completers is

   type Q_Completer is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Completer_Access is
     access all Q_Completer'Class;
   for Q_Completer_Access'Storage_Size use 0;

   type Q_Completer_Pointer is tagged;

   function Completion_Column
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Q_Integer;

   function Completion_Count
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Q_Integer;

   function Completion_Model
    (Self : not null access constant Q_Completer'Class)
       return not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;

   function Completion_Prefix
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Strings.Q_String;

   function Completion_Role
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Q_Integer;

   function Current_Completion
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Strings.Q_String;

   function Current_Index
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Model_Indices.Q_Model_Index;

   function Current_Row
    (Self : not null access constant Q_Completer'Class)
       return Qt4.Q_Integer;

   function Model
    (Self : not null access constant Q_Completer'Class)
       return not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;

   not overriding
   function Path_From_Index
    (Self : not null access constant Q_Completer;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Strings.Q_String
         is abstract;

   function Popup
    (Self : not null access constant Q_Completer'Class)
       return not null access Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class;

   procedure Set_Completion_Column
    (Self : not null access Q_Completer'Class;
     Column : Qt4.Q_Integer);

   procedure Set_Completion_Role
    (Self : not null access Q_Completer'Class;
     Role : Qt4.Q_Integer);

   function Set_Current_Row
    (Self : not null access Q_Completer'Class;
     Row : Qt4.Q_Integer)
       return Standard.Boolean;

   procedure Set_Model
    (Self : not null access Q_Completer'Class;
     C : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class);

   procedure Set_Popup
    (Self : not null access Q_Completer'Class;
     Popup : not null access Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class);

   procedure Set_Widget
    (Self : not null access Q_Completer'Class;
     Popup : not null access Qt4.Widgets.Q_Widget'Class);

   function Widget
    (Self : not null access constant Q_Completer'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Complete
    (Self : not null access Q_Completer'Class;
     Rect : Qt4.Rects.Q_Rect
       := Qt4.Rects.Create);

   procedure Set_Completion_Prefix
    (Self : not null access Q_Completer'Class;
     Prefix : Qt4.Strings.Q_String);

   package Q_Completer_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Completer, Q_Completer_Access);

   type Q_Completer_Pointer is
     new Q_Completer_Pointers.Q_Pointer with null record;

end Qt4.Completers;
